--- old/usr/src/uts/common/io/scsi/targets/sd.c	Mon Aug  5 17:31:49 2019
+++ new/usr/src/uts/common/io/scsi/targets/sd.c	Mon Aug  5 17:31:49 2019
@@ -860,298 +706,25 @@
 /*
  * Internal function prototypes
  */
+typedef struct unmap_param_hdr_s {
+	uint16_t	uph_data_len;
+	uint16_t	uph_descr_data_len;
+	uint32_t	uph_reserved;
+} unmap_param_hdr_t;
 
-#if (defined(__fibre))
-/*
- * These #defines are to avoid namespace collisions that occur because this
- * code is currently used to compile two separate driver modules: sd and ssd.
- * All function names need to be treated this way (even if declared static)
- * in order to allow the debugger to resolve the names properly.
- * It is anticipated that in the near future the ssd module will be obsoleted,
- * at which time this ugliness should go away.
- */
-#define	sd_log_trace			ssd_log_trace
-#define	sd_log_info			ssd_log_info
-#define	sd_log_err			ssd_log_err
-#define	sdprobe				ssdprobe
-#define	sdinfo				ssdinfo
-#define	sd_prop_op			ssd_prop_op
-#define	sd_scsi_probe_cache_init	ssd_scsi_probe_cache_init
-#define	sd_scsi_probe_cache_fini	ssd_scsi_probe_cache_fini
-#define	sd_scsi_clear_probe_cache	ssd_scsi_clear_probe_cache
-#define	sd_scsi_probe_with_cache	ssd_scsi_probe_with_cache
-#define	sd_scsi_target_lun_init		ssd_scsi_target_lun_init
-#define	sd_scsi_target_lun_fini		ssd_scsi_target_lun_fini
-#define	sd_scsi_get_target_lun_count	ssd_scsi_get_target_lun_count
-#define	sd_scsi_update_lun_on_target	ssd_scsi_update_lun_on_target
-#define	sd_spin_up_unit			ssd_spin_up_unit
-#define	sd_enable_descr_sense		ssd_enable_descr_sense
-#define	sd_reenable_dsense_task		ssd_reenable_dsense_task
-#define	sd_set_mmc_caps			ssd_set_mmc_caps
-#define	sd_read_unit_properties		ssd_read_unit_properties
-#define	sd_process_sdconf_file		ssd_process_sdconf_file
-#define	sd_process_sdconf_table		ssd_process_sdconf_table
-#define	sd_sdconf_id_match		ssd_sdconf_id_match
-#define	sd_blank_cmp			ssd_blank_cmp
-#define	sd_chk_vers1_data		ssd_chk_vers1_data
-#define	sd_set_vers1_properties		ssd_set_vers1_properties
-#define	sd_check_bdc_vpd		ssd_check_bdc_vpd
-#define	sd_check_emulation_mode		ssd_check_emulation_mode
+typedef struct unmap_blk_descr_s {
+	uint64_t	ubd_lba;
+	uint32_t	ubd_lba_cnt;
+	uint32_t	ubd_reserved;
+} unmap_blk_descr_t;
 
-#define	sd_get_physical_geometry	ssd_get_physical_geometry
-#define	sd_get_virtual_geometry		ssd_get_virtual_geometry
-#define	sd_update_block_info		ssd_update_block_info
-#define	sd_register_devid		ssd_register_devid
-#define	sd_get_devid			ssd_get_devid
-#define	sd_create_devid			ssd_create_devid
-#define	sd_write_deviceid		ssd_write_deviceid
-#define	sd_check_vpd_page_support	ssd_check_vpd_page_support
-#define	sd_setup_pm			ssd_setup_pm
-#define	sd_create_pm_components		ssd_create_pm_components
-#define	sd_ddi_suspend			ssd_ddi_suspend
-#define	sd_ddi_resume			ssd_ddi_resume
-#define	sd_pm_state_change		ssd_pm_state_change
-#define	sdpower				ssdpower
-#define	sdattach			ssdattach
-#define	sddetach			ssddetach
-#define	sd_unit_attach			ssd_unit_attach
-#define	sd_unit_detach			ssd_unit_detach
-#define	sd_set_unit_attributes		ssd_set_unit_attributes
-#define	sd_create_errstats		ssd_create_errstats
-#define	sd_set_errstats			ssd_set_errstats
-#define	sd_set_pstats			ssd_set_pstats
-#define	sddump				ssddump
-#define	sd_scsi_poll			ssd_scsi_poll
-#define	sd_send_polled_RQS		ssd_send_polled_RQS
-#define	sd_ddi_scsi_poll		ssd_ddi_scsi_poll
-#define	sd_init_event_callbacks		ssd_init_event_callbacks
-#define	sd_event_callback		ssd_event_callback
-#define	sd_cache_control		ssd_cache_control
-#define	sd_get_write_cache_enabled	ssd_get_write_cache_enabled
-#define	sd_get_write_cache_changeable	ssd_get_write_cache_changeable
-#define	sd_get_nv_sup			ssd_get_nv_sup
-#define	sd_make_device			ssd_make_device
-#define	sdopen				ssdopen
-#define	sdclose				ssdclose
-#define	sd_ready_and_valid		ssd_ready_and_valid
-#define	sdmin				ssdmin
-#define	sdread				ssdread
-#define	sdwrite				ssdwrite
-#define	sdaread				ssdaread
-#define	sdawrite			ssdawrite
-#define	sdstrategy			ssdstrategy
-#define	sdioctl				ssdioctl
-#define	sd_mapblockaddr_iostart		ssd_mapblockaddr_iostart
-#define	sd_mapblocksize_iostart		ssd_mapblocksize_iostart
-#define	sd_checksum_iostart		ssd_checksum_iostart
-#define	sd_checksum_uscsi_iostart	ssd_checksum_uscsi_iostart
-#define	sd_pm_iostart			ssd_pm_iostart
-#define	sd_core_iostart			ssd_core_iostart
-#define	sd_mapblockaddr_iodone		ssd_mapblockaddr_iodone
-#define	sd_mapblocksize_iodone		ssd_mapblocksize_iodone
-#define	sd_checksum_iodone		ssd_checksum_iodone
-#define	sd_checksum_uscsi_iodone	ssd_checksum_uscsi_iodone
-#define	sd_pm_iodone			ssd_pm_iodone
-#define	sd_initpkt_for_buf		ssd_initpkt_for_buf
-#define	sd_destroypkt_for_buf		ssd_destroypkt_for_buf
-#define	sd_setup_rw_pkt			ssd_setup_rw_pkt
-#define	sd_setup_next_rw_pkt		ssd_setup_next_rw_pkt
-#define	sd_buf_iodone			ssd_buf_iodone
-#define	sd_uscsi_strategy		ssd_uscsi_strategy
-#define	sd_initpkt_for_uscsi		ssd_initpkt_for_uscsi
-#define	sd_destroypkt_for_uscsi		ssd_destroypkt_for_uscsi
-#define	sd_uscsi_iodone			ssd_uscsi_iodone
-#define	sd_xbuf_strategy		ssd_xbuf_strategy
-#define	sd_xbuf_init			ssd_xbuf_init
-#define	sd_pm_entry			ssd_pm_entry
-#define	sd_pm_exit			ssd_pm_exit
+/* Max number of block descriptors in UNMAP command */
+#define	SD_UNMAP_MAX_DESCR \
+	((UINT16_MAX - sizeof (unmap_param_hdr_t)) / sizeof (unmap_blk_descr_t))
+/* Max size of the UNMAP parameter list in bytes */
+#define	SD_UNMAP_PARAM_LIST_MAXSZ	(sizeof (unmap_param_hdr_t) + \
+	SD_UNMAP_MAX_DESCR * sizeof (unmap_blk_descr_t))
 
-#define	sd_pm_idletimeout_handler	ssd_pm_idletimeout_handler
-#define	sd_pm_timeout_handler		ssd_pm_timeout_handler
-
-#define	sd_add_buf_to_waitq		ssd_add_buf_to_waitq
-#define	sdintr				ssdintr
-#define	sd_start_cmds			ssd_start_cmds
-#define	sd_send_scsi_cmd		ssd_send_scsi_cmd
-#define	sd_bioclone_alloc		ssd_bioclone_alloc
-#define	sd_bioclone_free		ssd_bioclone_free
-#define	sd_shadow_buf_alloc		ssd_shadow_buf_alloc
-#define	sd_shadow_buf_free		ssd_shadow_buf_free
-#define	sd_print_transport_rejected_message	\
-					ssd_print_transport_rejected_message
-#define	sd_retry_command		ssd_retry_command
-#define	sd_set_retry_bp			ssd_set_retry_bp
-#define	sd_send_request_sense_command	ssd_send_request_sense_command
-#define	sd_start_retry_command		ssd_start_retry_command
-#define	sd_start_direct_priority_command	\
-					ssd_start_direct_priority_command
-#define	sd_return_failed_command	ssd_return_failed_command
-#define	sd_return_failed_command_no_restart	\
-					ssd_return_failed_command_no_restart
-#define	sd_return_command		ssd_return_command
-#define	sd_sync_with_callback		ssd_sync_with_callback
-#define	sdrunout			ssdrunout
-#define	sd_mark_rqs_busy		ssd_mark_rqs_busy
-#define	sd_mark_rqs_idle		ssd_mark_rqs_idle
-#define	sd_reduce_throttle		ssd_reduce_throttle
-#define	sd_restore_throttle		ssd_restore_throttle
-#define	sd_print_incomplete_msg		ssd_print_incomplete_msg
-#define	sd_init_cdb_limits		ssd_init_cdb_limits
-#define	sd_pkt_status_good		ssd_pkt_status_good
-#define	sd_pkt_status_check_condition	ssd_pkt_status_check_condition
-#define	sd_pkt_status_busy		ssd_pkt_status_busy
-#define	sd_pkt_status_reservation_conflict	\
-					ssd_pkt_status_reservation_conflict
-#define	sd_pkt_status_qfull		ssd_pkt_status_qfull
-#define	sd_handle_request_sense		ssd_handle_request_sense
-#define	sd_handle_auto_request_sense	ssd_handle_auto_request_sense
-#define	sd_print_sense_failed_msg	ssd_print_sense_failed_msg
-#define	sd_validate_sense_data		ssd_validate_sense_data
-#define	sd_decode_sense			ssd_decode_sense
-#define	sd_print_sense_msg		ssd_print_sense_msg
-#define	sd_sense_key_no_sense		ssd_sense_key_no_sense
-#define	sd_sense_key_recoverable_error	ssd_sense_key_recoverable_error
-#define	sd_sense_key_not_ready		ssd_sense_key_not_ready
-#define	sd_sense_key_medium_or_hardware_error	\
-					ssd_sense_key_medium_or_hardware_error
-#define	sd_sense_key_illegal_request	ssd_sense_key_illegal_request
-#define	sd_sense_key_unit_attention	ssd_sense_key_unit_attention
-#define	sd_sense_key_fail_command	ssd_sense_key_fail_command
-#define	sd_sense_key_blank_check	ssd_sense_key_blank_check
-#define	sd_sense_key_aborted_command	ssd_sense_key_aborted_command
-#define	sd_sense_key_default		ssd_sense_key_default
-#define	sd_print_retry_msg		ssd_print_retry_msg
-#define	sd_print_cmd_incomplete_msg	ssd_print_cmd_incomplete_msg
-#define	sd_pkt_reason_cmd_incomplete	ssd_pkt_reason_cmd_incomplete
-#define	sd_pkt_reason_cmd_tran_err	ssd_pkt_reason_cmd_tran_err
-#define	sd_pkt_reason_cmd_reset		ssd_pkt_reason_cmd_reset
-#define	sd_pkt_reason_cmd_aborted	ssd_pkt_reason_cmd_aborted
-#define	sd_pkt_reason_cmd_timeout	ssd_pkt_reason_cmd_timeout
-#define	sd_pkt_reason_cmd_unx_bus_free	ssd_pkt_reason_cmd_unx_bus_free
-#define	sd_pkt_reason_cmd_tag_reject	ssd_pkt_reason_cmd_tag_reject
-#define	sd_pkt_reason_default		ssd_pkt_reason_default
-#define	sd_reset_target			ssd_reset_target
-#define	sd_start_stop_unit_callback	ssd_start_stop_unit_callback
-#define	sd_start_stop_unit_task		ssd_start_stop_unit_task
-#define	sd_taskq_create			ssd_taskq_create
-#define	sd_taskq_delete			ssd_taskq_delete
-#define	sd_target_change_task		ssd_target_change_task
-#define	sd_log_dev_status_event		ssd_log_dev_status_event
-#define	sd_log_lun_expansion_event	ssd_log_lun_expansion_event
-#define	sd_log_eject_request_event	ssd_log_eject_request_event
-#define	sd_media_change_task		ssd_media_change_task
-#define	sd_handle_mchange		ssd_handle_mchange
-#define	sd_send_scsi_DOORLOCK		ssd_send_scsi_DOORLOCK
-#define	sd_send_scsi_READ_CAPACITY	ssd_send_scsi_READ_CAPACITY
-#define	sd_send_scsi_READ_CAPACITY_16	ssd_send_scsi_READ_CAPACITY_16
-#define	sd_send_scsi_GET_CONFIGURATION	ssd_send_scsi_GET_CONFIGURATION
-#define	sd_send_scsi_feature_GET_CONFIGURATION	\
-					sd_send_scsi_feature_GET_CONFIGURATION
-#define	sd_send_scsi_START_STOP_UNIT	ssd_send_scsi_START_STOP_UNIT
-#define	sd_send_scsi_INQUIRY		ssd_send_scsi_INQUIRY
-#define	sd_send_scsi_TEST_UNIT_READY	ssd_send_scsi_TEST_UNIT_READY
-#define	sd_send_scsi_PERSISTENT_RESERVE_IN	\
-					ssd_send_scsi_PERSISTENT_RESERVE_IN
-#define	sd_send_scsi_PERSISTENT_RESERVE_OUT	\
-					ssd_send_scsi_PERSISTENT_RESERVE_OUT
-#define	sd_send_scsi_SYNCHRONIZE_CACHE	ssd_send_scsi_SYNCHRONIZE_CACHE
-#define	sd_send_scsi_SYNCHRONIZE_CACHE_biodone	\
-					ssd_send_scsi_SYNCHRONIZE_CACHE_biodone
-#define	sd_send_scsi_MODE_SENSE		ssd_send_scsi_MODE_SENSE
-#define	sd_send_scsi_MODE_SELECT	ssd_send_scsi_MODE_SELECT
-#define	sd_send_scsi_RDWR		ssd_send_scsi_RDWR
-#define	sd_send_scsi_LOG_SENSE		ssd_send_scsi_LOG_SENSE
-#define	sd_send_scsi_GET_EVENT_STATUS_NOTIFICATION	\
-				ssd_send_scsi_GET_EVENT_STATUS_NOTIFICATION
-#define	sd_gesn_media_data_valid	ssd_gesn_media_data_valid
-#define	sd_alloc_rqs			ssd_alloc_rqs
-#define	sd_free_rqs			ssd_free_rqs
-#define	sd_dump_memory			ssd_dump_memory
-#define	sd_get_media_info_com		ssd_get_media_info_com
-#define	sd_get_media_info		ssd_get_media_info
-#define	sd_get_media_info_ext		ssd_get_media_info_ext
-#define	sd_dkio_ctrl_info		ssd_dkio_ctrl_info
-#define	sd_nvpair_str_decode		ssd_nvpair_str_decode
-#define	sd_strtok_r			ssd_strtok_r
-#define	sd_set_properties		ssd_set_properties
-#define	sd_get_tunables_from_conf	ssd_get_tunables_from_conf
-#define	sd_setup_next_xfer		ssd_setup_next_xfer
-#define	sd_dkio_get_temp		ssd_dkio_get_temp
-#define	sd_check_mhd			ssd_check_mhd
-#define	sd_mhd_watch_cb			ssd_mhd_watch_cb
-#define	sd_mhd_watch_incomplete		ssd_mhd_watch_incomplete
-#define	sd_sname			ssd_sname
-#define	sd_mhd_resvd_recover		ssd_mhd_resvd_recover
-#define	sd_resv_reclaim_thread		ssd_resv_reclaim_thread
-#define	sd_take_ownership		ssd_take_ownership
-#define	sd_reserve_release		ssd_reserve_release
-#define	sd_rmv_resv_reclaim_req		ssd_rmv_resv_reclaim_req
-#define	sd_mhd_reset_notify_cb		ssd_mhd_reset_notify_cb
-#define	sd_persistent_reservation_in_read_keys	\
-					ssd_persistent_reservation_in_read_keys
-#define	sd_persistent_reservation_in_read_resv	\
-					ssd_persistent_reservation_in_read_resv
-#define	sd_mhdioc_takeown		ssd_mhdioc_takeown
-#define	sd_mhdioc_failfast		ssd_mhdioc_failfast
-#define	sd_mhdioc_release		ssd_mhdioc_release
-#define	sd_mhdioc_register_devid	ssd_mhdioc_register_devid
-#define	sd_mhdioc_inkeys		ssd_mhdioc_inkeys
-#define	sd_mhdioc_inresv		ssd_mhdioc_inresv
-#define	sr_change_blkmode		ssr_change_blkmode
-#define	sr_change_speed			ssr_change_speed
-#define	sr_atapi_change_speed		ssr_atapi_change_speed
-#define	sr_pause_resume			ssr_pause_resume
-#define	sr_play_msf			ssr_play_msf
-#define	sr_play_trkind			ssr_play_trkind
-#define	sr_read_all_subcodes		ssr_read_all_subcodes
-#define	sr_read_subchannel		ssr_read_subchannel
-#define	sr_read_tocentry		ssr_read_tocentry
-#define	sr_read_tochdr			ssr_read_tochdr
-#define	sr_read_cdda			ssr_read_cdda
-#define	sr_read_cdxa			ssr_read_cdxa
-#define	sr_read_mode1			ssr_read_mode1
-#define	sr_read_mode2			ssr_read_mode2
-#define	sr_read_cd_mode2		ssr_read_cd_mode2
-#define	sr_sector_mode			ssr_sector_mode
-#define	sr_eject			ssr_eject
-#define	sr_ejected			ssr_ejected
-#define	sr_check_wp			ssr_check_wp
-#define	sd_watch_request_submit		ssd_watch_request_submit
-#define	sd_check_media			ssd_check_media
-#define	sd_media_watch_cb		ssd_media_watch_cb
-#define	sd_delayed_cv_broadcast		ssd_delayed_cv_broadcast
-#define	sr_volume_ctrl			ssr_volume_ctrl
-#define	sr_read_sony_session_offset	ssr_read_sony_session_offset
-#define	sd_log_page_supported		ssd_log_page_supported
-#define	sd_check_for_writable_cd	ssd_check_for_writable_cd
-#define	sd_wm_cache_constructor		ssd_wm_cache_constructor
-#define	sd_wm_cache_destructor		ssd_wm_cache_destructor
-#define	sd_range_lock			ssd_range_lock
-#define	sd_get_range			ssd_get_range
-#define	sd_free_inlist_wmap		ssd_free_inlist_wmap
-#define	sd_range_unlock			ssd_range_unlock
-#define	sd_read_modify_write_task	ssd_read_modify_write_task
-#define	sddump_do_read_of_rmw		ssddump_do_read_of_rmw
-
-#define	sd_iostart_chain		ssd_iostart_chain
-#define	sd_iodone_chain			ssd_iodone_chain
-#define	sd_initpkt_map			ssd_initpkt_map
-#define	sd_destroypkt_map		ssd_destroypkt_map
-#define	sd_chain_type_map		ssd_chain_type_map
-#define	sd_chain_index_map		ssd_chain_index_map
-
-#define	sd_failfast_flushctl		ssd_failfast_flushctl
-#define	sd_failfast_flushq		ssd_failfast_flushq
-#define	sd_failfast_flushq_callback	ssd_failfast_flushq_callback
-
-#define	sd_is_lsi			ssd_is_lsi
-#define	sd_tg_rdwr			ssd_tg_rdwr
-#define	sd_tg_getinfo			ssd_tg_getinfo
-#define	sd_rmw_msg_print_handler	ssd_rmw_msg_print_handler
-
-#endif	/* #if (defined(__fibre)) */
-
-
 int _init(void);
 int _fini(void);
 int _info(struct modinfo *modinfop);
@@ -1201,7 +774,7 @@
  * Using sd_ssc_assessment to set correct type-of-assessment
  * Using sd_ssc_post to post ereport & system log
  *       sd_ssc_post will call sd_ssc_print to print system log
- *       sd_ssc_post will call sd_ssd_ereport_post to post ereport
+ *       sd_ssc_post will call sd_ssc_ereport_post to post ereport
  */
 static void sd_ssc_assessment(sd_ssc_t *ssc,
     enum sd_type_assessment tp_assess);
@@ -1253,8 +826,10 @@
 static int  sd_write_deviceid(sd_ssc_t *ssc);
 static int  sd_check_vpd_page_support(sd_ssc_t *ssc);
 
+#ifdef notyet
 static void sd_setup_pm(sd_ssc_t *ssc, dev_info_t *devi);
 static void sd_create_pm_components(dev_info_t *devi, struct sd_lun *un);
+#endif
 
 static int  sd_ddi_suspend(dev_info_t *devi);
 static int  sd_ddi_resume(dev_info_t *devi);
@@ -1263,7 +838,7 @@
 
 static int  sdattach(dev_info_t *devi, ddi_attach_cmd_t cmd);
 static int  sddetach(dev_info_t *devi, ddi_detach_cmd_t cmd);
-static int  sd_unit_attach(dev_info_t *devi);
+static void sd_unit_attach(void *arg);
 static int  sd_unit_detach(dev_info_t *devi);
 
 static void sd_set_unit_attributes(struct sd_lun *un, dev_info_t *devi);
@@ -1276,18 +851,9 @@
 static int  sd_send_polled_RQS(struct sd_lun *un);
 static int  sd_ddi_scsi_poll(struct scsi_pkt *pkt);
 
-#if (defined(__fibre))
 /*
- * Event callbacks (photon)
- */
-static void sd_init_event_callbacks(struct sd_lun *un);
-static void  sd_event_callback(dev_info_t *, ddi_eventcookie_t, void *, void *);
-#endif
-
-/*
  * Defines for sd_cache_control
  */
-
 #define	SD_CACHE_ENABLE		1
 #define	SD_CACHE_DISABLE	0
 #define	SD_CACHE_NOCHANGE	-1
@@ -1410,7 +976,7 @@
 	clock_t retry_delay, void (*statp)(kstat_io_t *));
 
 static void sd_send_request_sense_command(struct sd_lun *un, struct buf *bp,
-	struct scsi_pkt *pktp);
+	int retry_check_flag, struct scsi_pkt *pktp);
 static void sd_start_retry_command(void *arg);
 static void sd_start_direct_priority_command(void *arg);
 static void sd_return_failed_command(struct sd_lun *un, struct buf *bp,
@@ -1533,6 +1099,8 @@
 static int sd_send_scsi_SYNCHRONIZE_CACHE(struct sd_lun *un,
 	struct dk_callback *dkc);
 static int sd_send_scsi_SYNCHRONIZE_CACHE_biodone(struct buf *bp);
+static int sd_send_scsi_UNMAP(dev_t dev, sd_ssc_t *ssc, dkioc_free_list_t *dfl,
+	int flag);
 static int sd_send_scsi_GET_CONFIGURATION(sd_ssc_t *ssc,
 	struct uscsi_cmd *ucmdbuf, uchar_t *rqbuf, uint_t rqbuflen,
 	uchar_t *bufaddr, uint_t buflen, int path_flag);
@@ -1627,7 +1195,9 @@
 static int sr_volume_ctrl(dev_t dev, caddr_t data, int flag);
 static int sr_read_sony_session_offset(dev_t dev, caddr_t data, int flag);
 
+#ifdef notyet
 static int sd_log_page_supported(sd_ssc_t *ssc, int log_page);
+#endif
 
 /*
  * Function Prototype for the non-512 support (DVDRAM, MO etc.) functions.
@@ -1650,7 +1220,7 @@
 /*
  * Function prototypes for failfast support.
  */
-static void sd_failfast_flushq(struct sd_lun *un);
+static void sd_failfast_flushq(struct sd_lun *un, boolean_t flush_all);
 static int sd_failfast_flushq_callback(struct buf *bp);
 
 /*
@@ -1690,6 +1260,38 @@
 #define	SD_FAILFAST_ACTIVE		1
 
 /*
+ * Bitmask to control behaviour in failfast active state:
+ *
+ * SD_FAILFAST_ENABLE_FORCE_INACTIVE: When set, allow retries without
+ * SD_RETRIES_FAILFAST to cause transition to failfast inactive state.
+ *
+ * SD_FAILFAST_ENABLE_FAIL_RETRIES: When set, cause retries with the flag
+ * SD_RETRIES_FAILFAST set (following a timeout) to fail when in failfast
+ * active state.
+ *
+ * SD_FAILFAST_ENABLE_FAIL_ALL_RETRIES: When set, cause ALL retries,
+ * regardless of reason, to fail when in failfast active state. This takes
+ * precedence over SD_FAILFAST_FAIL_RETRIES.
+ *
+ * SD_FAILFAST_ENABLE_FAIL_USCSI: When set, discard all commands in the USCSI
+ * chain (sdioctl or driver generated) when in failfast active state.
+ * To prevent problems with sdopen, this is limited to when there are
+ * multiple pending commands.
+ */
+
+#define	SD_FAILFAST_ENABLE_FORCE_INACTIVE	0x01
+#define	SD_FAILFAST_ENABLE_FAIL_RETRIES		0x02
+#define	SD_FAILFAST_ENABLE_FAIL_ALL_RETRIES	0x04
+#define	SD_FAILFAST_ENABLE_FAIL_USCSI		0x08
+
+/*
+ * The default behaviour is to fail all retries due to timeout when in failfast
+ * active state, and not allow other retries to transition to inactive.
+ */
+static int sd_failfast_enable = SD_FAILFAST_ENABLE_FAIL_RETRIES |
+    SD_FAILFAST_ENABLE_FAIL_USCSI;
+
+/*
  * Bitmask to control behavior of buf(9S) flushes when a transition to
  * the failfast state occurs. Optional bits include:
  *
@@ -1705,18 +1307,22 @@
 #define	SD_FAILFAST_FLUSH_ALL_QUEUES	0x02
 
 /*
- * The default behavior is to only flush bufs that have B_FAILFAST set, but
- * to flush all queues within the driver.
+ * The default behavior is to flush all bufs in all queues within the driver.
  */
-static int sd_failfast_flushctl = SD_FAILFAST_FLUSH_ALL_QUEUES;
+static int sd_failfast_flushctl =
+    SD_FAILFAST_FLUSH_ALL_BUFS | SD_FAILFAST_FLUSH_ALL_QUEUES;
 
+#ifdef SD_FAULT_INJECTION
+static uint_t   sd_fault_injection_on = 0;
+#endif
 
 /*
  * SD Testing Fault Injection
  */
 #ifdef SD_FAULT_INJECTION
-static void sd_faultinjection_ioctl(int cmd, intptr_t arg, struct sd_lun *un);
+static int sd_faultinjection_ioctl(int cmd, intptr_t arg, struct sd_lun *un);
 static void sd_faultinjection(struct scsi_pkt *pktp);
+static void sd_prefaultinjection(struct scsi_pkt *pktp);
 static void sd_injection_log(char *buf, struct sd_lun *un);
 #endif
 
@@ -2372,10 +1978,6 @@
 /*
  * Macros used by functions to pass a given buf(9S) struct along to the
  * next function in the layering chain for further processing.
- *
- * In the following macros, passing more than three arguments to the called
- * routines causes the optimizer for the SPARC compiler to stop doing tail
- * call elimination which results in significant performance degradation.
  */
 #define	SD_BEGIN_IOSTART(index, un, bp)	\
 	((*(sd_iostart_chain[index]))(index, un, bp))
@@ -2568,7 +2170,6 @@
 		mutex_exit(&sd_log_mutex);
 	}
 #ifdef SD_FAULT_INJECTION
-	_NOTE(DATA_READABLE_WITHOUT_LOCK(sd_lun::sd_injection_mask));
 	if (un->sd_injection_mask & comp) {
 		mutex_enter(&sd_log_mutex);
 		va_start(ap, fmt);
@@ -2618,7 +2219,6 @@
 		mutex_exit(&sd_log_mutex);
 	}
 #ifdef SD_FAULT_INJECTION
-	_NOTE(DATA_READABLE_WITHOUT_LOCK(sd_lun::sd_injection_mask));
 	if (un->sd_injection_mask & component) {
 		mutex_enter(&sd_log_mutex);
 		va_start(ap, fmt);
@@ -2668,7 +2268,6 @@
 		mutex_exit(&sd_log_mutex);
 	}
 #ifdef SD_FAULT_INJECTION
-	_NOTE(DATA_READABLE_WITHOUT_LOCK(sd_lun::sd_injection_mask));
 	if (un->sd_injection_mask & component) {
 		mutex_enter(&sd_log_mutex);
 		va_start(ap, fmt);
@@ -2701,10 +2300,6 @@
 	int			rval;
 	int			instance = ddi_get_instance(devi);
 
-	/*
-	 * if it wasn't for pln, sdprobe could actually be nulldev
-	 * in the "__fibre" case.
-	 */
 	if (ddi_dev_is_sid(devi) == DDI_SUCCESS) {
 		return (DDI_PROBE_DONTCARE);
 	}
@@ -2731,36 +2326,16 @@
 			rval = DDI_PROBE_SUCCESS;
 			break;
 		case DTYPE_RODIRECT:
-			/* CDs etc. Can be removable media */
+			/* CDs etc. Can be removable media. */
 			rval = DDI_PROBE_SUCCESS;
 			break;
 		case DTYPE_OPTICAL:
 			/*
-			 * Rewritable optical driver HP115AA
-			 * Can also be removable media
+			 * Rewritable optical driver HP115AA.
+			 * Can also be removable media.
 			 */
-
-			/*
-			 * Do not attempt to bind to  DTYPE_OPTICAL if
-			 * pre solaris 9 sparc sd behavior is required
-			 *
-			 * If first time through and sd_dtype_optical_bind
-			 * has not been set in /etc/system check properties
-			 */
-
-			if (sd_dtype_optical_bind  < 0) {
-				sd_dtype_optical_bind = ddi_prop_get_int
-				    (DDI_DEV_T_ANY, devi, 0,
-				    "optical-device-bind", 1);
-			}
-
-			if (sd_dtype_optical_bind == 0) {
-				rval = DDI_PROBE_FAILURE;
-			} else {
-				rval = DDI_PROBE_SUCCESS;
-			}
+			rval = DDI_PROBE_SUCCESS;
 			break;
-
 		case DTYPE_NOTPRESENT:
 		default:
 			rval = DDI_PROBE_FAILURE;
@@ -2860,12 +2435,25 @@
 	struct sd_lun	*un;
 
 	if ((un = ddi_get_soft_state(sd_state, ddi_get_instance(dip))) == NULL)
-		return (ddi_prop_op(dev, dip, prop_op, mod_flags,
-		    name, valuep, lengthp));
+		goto fallback;
 
+	mutex_enter(SD_MUTEX(un));
+	while ((un->un_state == SD_STATE_ATTACHING))
+		cv_wait(&un->un_suspend_cv, SD_MUTEX(un));
+
+	if (un->un_state == SD_STATE_ATTACH_FAILED) {
+		mutex_exit(SD_MUTEX(un));
+		goto fallback;
+	}
+	mutex_exit(SD_MUTEX(un));
+
 	return (cmlb_prop_op(un->un_cmlbhandle,
 	    dev, dip, prop_op, mod_flags, name, valuep, lengthp,
 	    SDPART(dev), (void *)SD_PATH_DIRECT));
+
+fallback:
+	return (ddi_prop_op(dev, dip, prop_op, mod_flags, name, valuep,
+	    lengthp));
 }
 
 /*
@@ -3213,9 +2801,13 @@
 	status = sd_send_scsi_START_STOP_UNIT(ssc, SD_START_STOP,
 	    SD_TARGET_START, SD_PATH_DIRECT);
 
-	if (status != 0) {
-		if (status == EACCES)
-			has_conflict = TRUE;
+	switch (status) {
+	case EIO:
+		sd_ssc_assessment(ssc, SD_FMT_STATUS_CHECK);
+		return (status);
+	case EACCES:
+		has_conflict = TRUE;
+	default: /*FALLTHROUGH*/
 		sd_ssc_assessment(ssc, SD_FMT_IGNORE);
 	}
 
@@ -3834,7 +3426,7 @@
 
 	/* Obtain the configuration list associated with the .conf file */
 	if (ddi_prop_lookup_string_array(DDI_DEV_T_ANY, SD_DEVINFO(un),
-	    DDI_PROP_DONTPASS | DDI_PROP_NOTPROM, sd_config_list,
+	    DDI_PROP_DONTPASS | DDI_PROP_NOTPROM, "sd-config-list",
 	    &config_list, &nelements) != DDI_PROP_SUCCESS) {
 		return (SD_FAILURE);
 	}
@@ -4198,6 +3790,7 @@
 		    ISP2(val) && val >= un->un_tgt_blocksize &&
 		    val >= un->un_sys_blocksize) {
 			un->un_phy_blocksize = val;
+			un->un_f_sdconf_phy_blocksize = TRUE;
 		} else {
 			goto value_invalid;
 		}
@@ -4205,6 +3798,30 @@
 		    "physical block size set to %d\n", un->un_phy_blocksize);
 	}
 
+	if (strcasecmp(name, "slow-io-threshold") == 0) {
+		if (ddi_strtol(value, &endptr, 0, &val) == 0) {
+			un->un_slow_io_threshold = (hrtime_t)val * NANOSEC;
+		} else {
+			un->un_slow_io_threshold =
+			    (hrtime_t)sd_slow_io_threshold;
+			goto value_invalid;
+		}
+		SD_INFO(SD_LOG_ATTACH_DETACH, un, "sd_set_properties: "
+		    "slow IO threshold set to %llu\n",
+		    un->un_slow_io_threshold);
+	}
+
+	if (strcasecmp(name, "io-time") == 0) {
+		if (ddi_strtol(value, &endptr, 0, &val) == 0) {
+			un->un_io_time = val;
+		} else {
+			un->un_io_time = sd_io_time;
+			goto value_invalid;
+		}
+		SD_INFO(SD_LOG_ATTACH_DETACH, un, "sd_set_properties: "
+		    "IO time set to %llu\n", un->un_io_time);
+	}
+
 	if (strcasecmp(name, "retries-victim") == 0) {
 		if (ddi_strtol(value, &endptr, 0, &val) == 0) {
 			un->un_victim_retry_count = val;
@@ -4966,7 +4583,6 @@
 	 * or later for a direct-attached block device if the SCSI version is
 	 * at least SPC-3.
 	 */
-
 	if (ISCD(un) ||
 	    un->un_interconnect_type == SD_INTERCONNECT_SATA ||
 	    (un->un_ctype == CTYPE_CCS && SD_INQUIRY(un)->inq_ansi >= 5))
@@ -5308,8 +4924,90 @@
 	}
 }
 
+/*
+ * Parses the SCSI Block Limits VPD page (0xB0). It's legal to pass NULL for
+ * vpd_pg, in which case all the block limits will be reset to the defaults.
+ */
+static void
+sd_parse_blk_limits_vpd(struct sd_lun *un, uchar_t *vpd_pg)
+{
+	sd_blk_limits_t *lim = &un->un_blk_lim;
+	unsigned pg_len;
 
+	if (vpd_pg != NULL)
+		pg_len = BE_IN16(&vpd_pg[2]);
+	else
+		pg_len = 0;
+
+	/* Block Limits VPD can be 16 bytes or 64 bytes long - support both */
+	if (pg_len >= 0x10) {
+		lim->lim_opt_xfer_len_gran = BE_IN16(&vpd_pg[6]);
+		lim->lim_max_xfer_len = BE_IN32(&vpd_pg[8]);
+		lim->lim_opt_xfer_len = BE_IN32(&vpd_pg[12]);
+	} else {
+		lim->lim_opt_xfer_len_gran = 0;
+		lim->lim_max_xfer_len = UINT32_MAX;
+		lim->lim_opt_xfer_len = UINT32_MAX;
+	}
+	if (pg_len >= 0x3c) {
+		lim->lim_max_pfetch_len = BE_IN32(&vpd_pg[16]);
+		/*
+		 * A zero in either of the following two fields indicates lack
+		 * of UNMAP support.
+		 */
+		lim->lim_max_unmap_lba_cnt = BE_IN32(&vpd_pg[20]);
+		lim->lim_max_unmap_descr_cnt = BE_IN32(&vpd_pg[24]);
+		lim->lim_opt_unmap_gran = BE_IN32(&vpd_pg[28]);
+		if ((vpd_pg[32] >> 7) == 1) {
+			/* left-most bit on each byte is a flag */
+			lim->lim_unmap_gran_align =
+			    ((vpd_pg[32] & 0x7f) << 24) | (vpd_pg[33] << 16) |
+			    (vpd_pg[34] << 8) | vpd_pg[35];
+		} else {
+			lim->lim_unmap_gran_align = 0;
+		}
+		lim->lim_max_write_same_len = BE_IN64(&vpd_pg[36]);
+	} else {
+		lim->lim_max_pfetch_len = UINT32_MAX;
+		lim->lim_max_unmap_lba_cnt = UINT32_MAX;
+		lim->lim_max_unmap_descr_cnt = SD_UNMAP_MAX_DESCR;
+		lim->lim_opt_unmap_gran = 0;
+		lim->lim_unmap_gran_align = 0;
+		lim->lim_max_write_same_len = UINT64_MAX;
+	}
+}
+
 /*
+ * Collects VPD page B0 data if available (block limits). If the data is
+ * not available or querying the device failed, we revert to the defaults.
+ */
+static void
+sd_setup_blk_limits(sd_ssc_t *ssc)
+{
+	struct sd_lun	*un		= ssc->ssc_un;
+	uchar_t		*inqB0		= NULL;
+	size_t		inqB0_resid	= 0;
+	int		rval;
+
+	if (un->un_vpd_page_mask & SD_VPD_BLK_LIMITS_PG) {
+		inqB0 = kmem_zalloc(MAX_INQUIRY_SIZE, KM_SLEEP);
+		rval = sd_send_scsi_INQUIRY(ssc, inqB0, MAX_INQUIRY_SIZE, 0x01,
+		    0xB0, &inqB0_resid);
+		if (rval != 0) {
+			sd_ssc_assessment(ssc, SD_FMT_IGNORE);
+			kmem_free(inqB0, MAX_INQUIRY_SIZE);
+			inqB0 = NULL;
+		}
+	}
+	/* passing NULL inqB0 will reset to defaults */
+	sd_parse_blk_limits_vpd(ssc->ssc_un, inqB0);
+	if (inqB0)
+		kmem_free(inqB0, MAX_INQUIRY_SIZE);
+}
+
+#define	DEVID_IF_KNOWN(d) "devid", DATA_TYPE_STRING, (d) ? (d) : "unknown"
+
+/*
  *    Function: sd_register_devid
  *
  * Description: This routine will obtain the device id information from the
@@ -5440,20 +5138,14 @@
 	 * on the drive and have them fabricated by the ddi layer by calling
 	 * ddi_devid_init and passing the DEVID_FAB flag.
 	 */
-	if (un->un_f_opt_fab_devid == TRUE) {
-		/*
-		 * Depending on EINVAL isn't reliable, since a reserved disk
-		 * may result in invalid geometry, so check to make sure a
-		 * reservation conflict did not occur during attach.
-		 */
-		if ((sd_get_devid(ssc) == EINVAL) &&
-		    (reservation_flag != SD_TARGET_IS_RESERVED)) {
+	if (un->un_f_opt_fab_devid == TRUE &&
+	    reservation_flag != SD_TARGET_IS_RESERVED) {
+		if (sd_get_devid(ssc) == EINVAL)
 			/*
 			 * The devid is invalid AND there is no reservation
 			 * conflict.  Fabricate a new devid.
 			 */
 			(void) sd_create_devid(ssc);
-		}
 
 		/* Register the devid if it exists */
 		if (un->un_devid != NULL) {
@@ -5475,7 +5167,7 @@
 		/* devid successfully encoded, register devid */
 		(void) ddi_devid_register(SD_DEVINFO(un), un->un_devid);
 
-	} else {
+	} else if (reservation_flag != SD_TARGET_IS_RESERVED) {
 		/*
 		 * Unable to encode a devid based on data available.
 		 * This is not a Sun qualified disk.  Older Sun disk
@@ -5837,6 +5529,9 @@
 			case 0x86:
 				un->un_vpd_page_mask |= SD_VPD_EXTENDED_DATA_PG;
 				break;
+			case 0xB0:
+				un->un_vpd_page_mask |= SD_VPD_BLK_LIMITS_PG;
+				break;
 			case 0xB1:
 				un->un_vpd_page_mask |= SD_VPD_DEV_CHARACTER_PG;
 				break;
@@ -5865,7 +5560,7 @@
  *
  *     Context: Kernel Thread
  */
-
+#ifdef notyet
 static void
 sd_setup_pm(sd_ssc_t *ssc, dev_info_t *devi)
 {
@@ -5920,6 +5615,7 @@
 				un->un_f_power_condition_supported = FALSE;
 			}
 		}
+		/* WTF? this fails for optical drives with no media */
 		if (!un->un_f_power_condition_supported) {
 			rval = sd_send_scsi_START_STOP_UNIT(ssc,
 			    SD_START_STOP, SD_TARGET_START, SD_PATH_DIRECT);
@@ -6121,8 +5817,8 @@
 	mutex_exit(&un->un_pm_mutex);
 	mutex_exit(SD_MUTEX(un));
 }
+#endif
 
-
 /*
  *    Function: sd_ddi_suspend
  *
@@ -6295,25 +5991,6 @@
 		mutex_enter(SD_MUTEX(un));
 	}
 
-	if (un->un_f_is_fibre == TRUE) {
-		/*
-		 * Remove callbacks for insert and remove events
-		 */
-		if (un->un_insert_event != NULL) {
-			mutex_exit(SD_MUTEX(un));
-			(void) ddi_remove_event_handler(un->un_insert_cb_id);
-			mutex_enter(SD_MUTEX(un));
-			un->un_insert_event = NULL;
-		}
-
-		if (un->un_remove_event != NULL) {
-			mutex_exit(SD_MUTEX(un));
-			(void) ddi_remove_event_handler(un->un_remove_cb_id);
-			mutex_enter(SD_MUTEX(un));
-			un->un_remove_event = NULL;
-		}
-	}
-
 	mutex_exit(SD_MUTEX(un));
 
 	SD_TRACE(SD_LOG_IO_PM, un, "sd_ddi_suspend: exit\n");
@@ -6395,17 +6072,6 @@
 		scsi_watch_resume(un->un_swr_token);
 	}
 
-#if (defined(__fibre))
-	if (un->un_f_is_fibre == TRUE) {
-		/*
-		 * Add callbacks for insert and remove events
-		 */
-		if (strcmp(un->un_node_type, DDI_NT_BLOCK_CHAN)) {
-			sd_init_event_callbacks(un);
-		}
-	}
-#endif
-
 	/*
 	 * Transport any pending commands to the target.
 	 *
